SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: 'JinwooLee 8/3/2012 21:21' prior: 0!
A cell in the game.!

!LOCell methodsFor: 'initialization' stamp: 'JinwooLee 8/3/2012 21:24'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!LOCell methodsFor: 'accessing' stamp: 'JinwooLee 8/4/2012 01:51'!
mouseAction: aBlock
	^ mouseAction := aBlock.! !

!LOCell methodsFor: 'event handling' stamp: 'JinwooLee 8/4/2012 01:54'!
mouseUp: anEvent
	mouseAction value.! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'JinwooLee 8/4/2012 01:36'!
cellsPerSide
	"The number of cells along each side of the game."
	^ 10.! !

!LOGame methodsFor: 'initialization' stamp: 'JinwooLee 8/4/2012 01:24'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width * n) @ (height * n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'initialization' stamp: 'JinwooLee 8/4/2012 02:02'!
newCellAt: i at: j
	"Create a cell for position (i, j) and add it to my on-screen
	representation at the appropriate screen position. Answer the new cell."

	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [ self toggleNeighboursOfCellAt: i at: j ].
	^ c.! !

!LOGame methodsFor: 'game logic' stamp: 'JinwooLee 8/4/2012 01:48'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j) toggleState ].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState ].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState ].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState ].! !
